% This is a demo for the linear classifier depedency modeling (LCDM) algorithm

% Please cite our paper, if you use this code for your project. Thanks.
% A J Ma, P C Yuen and J H Lai, "Linear dependency modeling for classifier fusion and feature combination",
% IEEE Trans. Pattern Analysis and Machine Intelligence, vol. 35, no. 5, pp. 1135-1148, 2013.

clear
clc

load scores_kth

num_classes = size(scores_train, 3);
num_feas = size(scores_train, 2);
num_test_veds = length(tag_test);

v = 0.1;
Q = 10;
beta = lcdm(scores_train, tag_train, v, Q);
beta = reshape(beta, [1 num_feas num_classes]);
scores_test_fusion = reshape(sum(repmat(beta, [num_test_veds 1 1]) .* scores_test, 2), [num_test_veds num_classes]);
[tmp tag_predict] = max(scores_test_fusion, [], 2);
acc = sum(tag_predict' == tag_test) / length(tag_test);
