% This is a demo for the linear feature depedency modeling (LFDM) algorithm

% Please cite our paper, if you use this code for your project. Thanks.
% A J Ma, P C Yuen and J H Lai, "Linear dependency modeling for classifier fusion and feature combination",
% IEEE Trans. Pattern Analysis and Machine Intelligence, vol. 35, no. 5, pp. 1135-1148, 2013.

clear
clc

load prob_kth

feas_sele = [2 4];
num_feas = length(feas_sele);
prob_train = prob_train(:,:,feas_sele,:);
prob_test = prob_test(:,:,feas_sele,:);

num_classes = size(prob_train, 4);
dim_fea = size(prob_train, 2);
num_test = length(tag_test);

v = 0.1;
Q = num_feas*dim_fea;
gamma = lfdm(prob_train, tag_train, v, Q);
gamma = reshape(gamma, [1 dim_fea num_feas num_classes]);
scores_test_fusion = reshape(sum(sum(repmat(gamma, [num_test 1 1 1]) .* prob_test, 2),3), [num_test num_classes]);
[tmp tag_predict] = max(scores_test_fusion, [], 2);
acc = sum(tag_predict' == tag_test) / length(tag_test);
