function fea_vecs = Desc_SIFT_3D(vol_dx, vol_dy, pos_xyz, sx2, st2, dd_sift, dt_sift, num_direct)

size_vol_feas = size(vol_dx);

st = floor(st2/2);
sx = floor(sx2/2);
ut = unique(pos_xyz(:,3));
num_t = length(ut);

x = 1:2*sx/dd_sift:(2*sx+1);
y = x;
t = 1:2*st/dt_sift:(2*st+1);
nx = length(x);
ny = length(y);
nt = length(t);

num_pts = size(pos_xyz, 1);
fea_vecs = zeros(num_direct*prod([nx ny nt]-1), num_pts);
thetas = 0:2*pi/num_direct:2*pi;
cos_thres = cos(thetas);
sin_thres = sin(thetas);



n = 1;
for i = 1:num_t
    pos_xy = pos_xyz(pos_xyz(:,3)==ut(i),1:2);
    for j = 1:size(pos_xy,1)
        if ut(i)-st > 0 && ut(i)+st < size_vol_feas(3)
            num_fr = 2*st+1;
            loc_vol_dx = vol_dx(pos_xy(j,1)-sx : pos_xy(j,1)+sx, pos_xy(j,2)-sx : pos_xy(j,2)+sx, ...
                ut(i)-st:ut(i)+st);
            loc_vol_dy = vol_dy(pos_xy(j,1)-sx : pos_xy(j,1)+sx, pos_xy(j,2)-sx : pos_xy(j,2)+sx, ...
                ut(i)-st:ut(i)+st);
        end
        if ut(i)-st < 1
            num_fr = ut(i)+st;
            loc_vol_dx = vol_dx(pos_xy(j,1)-sx : pos_xy(j,1)+sx, pos_xy(j,2)-sx : pos_xy(j,2)+sx, ...
                1:ut(i)+st);
            loc_vol_dy = vol_dy(pos_xy(j,1)-sx : pos_xy(j,1)+sx, pos_xy(j,2)-sx : pos_xy(j,2)+sx, ...
                1:ut(i)+st);
        end
        if ut(i)+st > size_vol_feas(3)
            num_fr = size_vol_feas(3) - ut(i) + st + 1;
            loc_vol_dx = vol_dx(pos_xy(j,1)-sx : pos_xy(j,1)+sx, pos_xy(j,2)-sx : pos_xy(j,2)+sx, ...
                ut(i)-st : size_vol_feas(3));      
            loc_vol_dy = vol_dy(pos_xy(j,1)-sx : pos_xy(j,1)+sx, pos_xy(j,2)-sx : pos_xy(j,2)+sx, ...
                ut(i)-st : size_vol_feas(3));  
        end
        if ut(i)-st < 1
            loc_vol_dx(:,:,2*st+2-num_fr:2*st+1) = loc_vol_dx;
            loc_vol_dx(:,:,1:2*st+1-num_fr) = repmat(loc_vol_dx(:,:,1), [1 1 2*st+1-num_fr]);
            loc_vol_dy(:,:,2*st+2-num_fr:2*st+1) = loc_vol_dy;
            loc_vol_dy(:,:,1:2*st+1-num_fr) = repmat(loc_vol_dy(:,:,1), [1 1 2*st+1-num_fr]);
        end
        if ut(i)+st > size_vol_feas(3)
            loc_vol_dx(:,:,num_fr+1:2*st+1) = repmat(loc_vol_dx(:,:,end), [1 1 2*st+1-num_fr]);
            loc_vol_dy(:,:,num_fr+1:2*st+1) = repmat(loc_vol_dy(:,:,end), [1 1 2*st+1-num_fr]);
        end
        m = 1;
        for ix = 1:nx-1
            for iy = 1:ny-1
                for it = 1:nt-1
                    dx_loc_vol = loc_vol_dx(x(ix):x(ix+1),y(iy):y(iy+1),t(it):t(it+1));
                    dy_loc_vol = loc_vol_dy(x(ix):x(ix+1),y(iy):y(iy+1),t(it):t(it+1));
                    dr_loc_vol = sqrt(dx_loc_vol .^ 2 + dy_loc_vol .^ 2);
                    cos_theta = dx_loc_vol(:) ./ dr_loc_vol(:);
                    sin_theta = dy_loc_vol(:) ./ dr_loc_vol(:);
                    for k = 1:num_direct
                        cos_interval = [min(cos_thres(k:k+1)) max(cos_thres(k:k+1))];
                        sin_interval = [min(sin_thres(k:k+1)) max(sin_thres(k:k+1))];
                        fea_vecs(m,n) = sum(cos_theta >= cos_interval(1) & cos_theta <= cos_interval(2) ...
                            & sin_theta >= sin_interval(1) & sin_theta <= sin_interval(2));                        
                        m = m + 1;
                    end
                end
            end
        end
        fea_vecs(:,n) = fea_vecs(:,n) / (2*sx+2)^2 / (2*st+2) * prod([nx ny nt]-1);
        n = n + 1;
    end
end