function [pos_xyz vol]= STIP_Det(filename, num_fr, num_pt, sxl2, stl2, test_show)

volinfo = aviinfo(filename);

if volinfo.NumFrames < num_fr
    num_fr = volinfo.NumFrames;
end

vol = zeros(volinfo.Height, volinfo.Width, num_fr);
vidobj = mmreader(filename);
for i = 1:num_fr
    im = read(vidobj,i);
    im = rgb2gray(im);
    vol(:,:,i) = im;
end

respond_im = stfeatures_periodic(vol, sxl2, stl2);
threshold = max(respond_im(:)) / 100;
respond_im(respond_im < threshold) = 0;    
[pos_xyz val] = locmax26(respond_im);
[tmp ind] = sort(-val);
if length(val) < num_pt
    num_pt = length(val);
end
pos_xyz = uint32(pos_xyz(ind(1:num_pt),:));

% show STIP
if nargin < 6
    test_show = 0;
end
if test_show
%     aviobj = avifile('example2.avi');
    fig=figure;
    clear ind
    for i = 1:num_fr
        imshow(uint8(vol(:,:,i))), hold on
        ind = pos_xyz(:,3)==i;
        if sum(ind) > 0
            pos = pos_xyz(ind,1:2);
            for j = 1:size(pos,1)
                plot(pos(j,2),pos(j,1),'o','Color',[1 0 0],'MarkerSize',6);
            end
        end
        drawnow;
        hold off
        F = getframe(gcf);
        pause(0.1)
%         aviobj = addframe(aviobj,F);
    end
    close(fig)
%     aviobj = close(aviobj);
end


